/* This is the phone program, written by David Ashley
 * dash@xdr.com
 * http://www.xdr.com/dash
 * This program is released under the terms of the GPL
 */
/*
 * prototype GTK front end Lee Benfield 06/03/2000
 * lee@recoil.org
 */


#include <stdlib.h>
#include <gtk/gtk.h>
#include "gtkphone.h"
#include "phone.h"
#include "user_info.h"

#define _(x) x
#define SERVER "matcher.xdr.com"

#define MAXBLOCKS 14
#define LISTDELAYTIME 3000
/*
 * Because we can't tell between who and list, we have to send them 
 * quite well spaced.
 */

/*
 * if we're expecting info about our address book, 0
 * if we're expecting a "who's online", 1.
 */
GtkWidget *clist1;
GtkWidget *popup_dlg;
GtkWidget *online_dlg;
GtkWidget *popup_label;

char exitflag=0;
int talktries=-1;
long nextsendtalk;
long lastdiff,latency;
int block160size;
int sndin,sndblocksize;
unsigned char sndblock1[16384],sndblock2[16384];
char username[MAXNAMESIZE];
char calling[MAXNAMESIZE];
int tryingtocall=0;
unsigned char myhash[8];
unsigned char mykey[8];
T_bucket userInfo;
/*
 * Gtk dsp callbacks
 */
int incomingDspHandle = 0;
int outgoingDspHandle = 0;


int connected=0;
int gottalk=0;

long incount,outcount;

#define WRITEFIFOMAX 64
unsigned char *writeput,*writetake,*writelimit;
int writein;
unsigned char writefifo[1024*WRITEFIFOMAX];
int loudcount;

unsigned char myip[16];
int myiplen;


long dspopentime;
long totalwritten;
long totalread;


#define PACKETSTOPACK 5
unsigned char packed[32+PACKETSTOPACK*33];
int packedin;

int havedsp=0;


opendsp() {
   int t;
   int res;
   int pid;
   

   if(havedsp) return 0;
   sndin=open("/dev/dsp",O_RDWR);
   if(sndin<0) return -1;
   
   /*
    t=8;
    res=ioctl(sndin,SNDCTL_DSP_SAMPLESIZE,&t);
    if(res) return -2;
    */
   
   t=8000;
   res=ioctl(sndin,SNDCTL_DSP_SPEED,&t);
   if(res) return -3;
   
   t=1;
   res=ioctl(sndin,SNDCTL_DSP_CHANNELS,&t);
   if(res) return -4;
   
   
   res=ioctl(sndin,SNDCTL_DSP_GETFMTS,&t);
   
   if(!(t&AFMT_S16_LE)) {
      printf("Digitizing in 8 bit mode\n");
      block160size=160;
      t=AFMT_U8;
      res=ioctl(sndin,SNDCTL_DSP_SETFMT,&t);
      if(res) return -6;
      t=0x20008;
      res=ioctl(sndin,SNDCTL_DSP_SETFRAGMENT,&t);
      if(res) return -5;
   } else {
      printf("Digitizing in 16 bit mode\n");
      block160size=160*2;
      t=AFMT_S16_LE;
      res=ioctl(sndin,SNDCTL_DSP_SETFMT,&t);
      if(res) return -6;
      t=0x20009;
      res=ioctl(sndin,SNDCTL_DSP_SETFRAGMENT,&t);
      if(res) return -5;
   }
   
   //	t=0;res=ioctl(sndin,SNDCTL_DSP_SETFMT,&t);
   
   res=ioctl(sndin,SNDCTL_DSP_GETCAPS,&t);
   if(res) return -7;
   if(!(t&DSP_CAP_DUPLEX)) {
      printf("Your soundcard/driver combination isn't allowing full duplex.\n");
      printf("That means you can't read from the microphone and write to\n");
      printf("the speakers at the same time.\n");
      printf("Unfortunately, this program depends on this capability.\n");
      return -8;
   }
   
   res=ioctl(sndin,SNDCTL_DSP_GETBLKSIZE,&sndblocksize);
   if(res) return -9;
   
   havedsp=1;
   incomingDspHandle = gdk_input_add(sndin, GDK_INPUT_READ, incoming_dsp_callback, NULL); // that is, incoming from the microphone.
   outgoingDspHandle = gdk_input_add(sndin, GDK_INPUT_WRITE, outgoing_dsp_callback, NULL);
   read(sndin,sndblock1,sndblocksize);
   writeput=writetake=writefifo;
   writelimit=writefifo+WRITEFIFOMAX*sndblocksize;
   writein=0;
   packedin=0;
   
   dspopentime=gtime2();
   totalwritten=0;
   totalread=0;
   
   return 0;
}

tryopendsp() {
   int result;
   if(result=opendsp()) {
      printf("Failed to open dsp, result code %d\n",result);
      exit(1);
   }
   incount=-1;
   outcount=0;
}

void dropDspHandles (void) {      
   if (incomingDspHandle) {
      gdk_input_remove(incomingDspHandle);
      incomingDspHandle = 0;
   }
   if (outgoingDspHandle) {
      gdk_input_remove(outgoingDspHandle);
      outgoingDspHandle = 0;
   }
}

closedsp() {
   if(havedsp) {
      close(sndin);
      havedsp=0;
      dropDspHandles();
   }
}


int openserver(char *mname,int port)
{
struct hostent *hostptr;
int status;
	hostptr=gethostbyname(mname);
	if(!hostptr)
	{
		hostptr=gethostbyaddr(mname,strlen(mname),AF_INET);
		if(!hostptr)
			return 0;
	}
	memset(&servername,0,sizeof(servername));
	servername.sin_family=AF_INET;
	servername.sin_port=htons(port);
	memcpy(&servername.sin_addr,hostptr->h_addr,hostptr->h_length);
	return 1;
}

void messagetoserver(unsigned char *m,int len)
{
unsigned char temp[512],*p,*p2;
int i;

	p=temp;
	*p++=CODE_CRYPT;
	memcpy(p,myhash,HASHSIZE);p+=HASHSIZE;
	p2=p;
	memcpy(p,specialkey,sizeof(specialkey));p+=sizeof(specialkey);
	memcpy(p,m,len);p+=len;
	len+=sizeof(specialkey);
	while(len&7)
	{
		*p++=0;
		++len;
	}
	i=len;
	while(--i>0)
	{
		p2[1]^=*p2;
		++p2;
	}
	encryptblock(temp+HASHSIZE+1,len,mykey);
/*
{
int i;
for(i=0;i<p-temp;++i) printf(" %02x",temp[i]);printf("\n");
}
*/
	putmsg(&servername,temp,p-temp);
}


gint populateList(gpointer data) {
   T_bucket uic = userInfo->next;
   for ( ; uic ; uic = uic->next ) {
      char * data[2];
      data[0] = uic->online ? "Y" : "N";
      data[1] = uic->name;
      printf ("%s, %s %s\n",data[0],data[1],uic->name);
      gtk_clist_append(GTK_CLIST(clist1),data);
   }
   return FALSE;
}

gint updateList(gpointer data) {
   gtk_clist_clear(GTK_CLIST(clist1));
   ChainDestroy(userInfo);
   processtyped(10,"");
   processtyped(2,"");
   gtk_timeout_add(LISTDELAYTIME,populateList,NULL);
   return FALSE;
}
   
gint buttonUpdateClist(GtkWidget *widget, gpointer data) {
   updateList(data);
   return FALSE;
}

gint buttonEndConversation(GtkWidget *widget, gpointer data) {
   processtyped(3,"");
   return FALSE;
}

gint answerTalkRequest(GtkWidget *widget, gpointer data) {
   processtyped(7,"");
   gtk_widget_hide(popup_dlg);
   if (GTK_WIDGET_VISIBLE (online_dlg)) {
   } else {
      gtk_widget_show(online_dlg);
   }
   return FALSE;
}

gint ignoreTalkRequest(GtkWidget *widget, gpointer data) {
   gtk_widget_hide(popup_dlg);
   return FALSE;
}

gint registerme(gpointer data) {
   int t;
   printf ("registerme\n");
   mesg[0]=CODE_IAM;
   memcpy(mesg+1,myip,4);
   t=ntohs(myname.sin_port);
   mesg[5]=t>>8;
   mesg[6]=t;
   messagetoserver(mesg,1+6);
   return TRUE;
}

void unregisterme(void) {
   int t;
   printf ("unregisterme\n");
   mesg[0]=CODE_IAMNOT;
   memcpy(mesg+1,myip,4);
   t=ntohs(myname.sin_port);
   mesg[5]=t>>8;
   mesg[6]=t;
   messagetoserver(mesg,1+6);
}

gint endProgram( GtkWidget *widget,
		GdkEvent  *event,
		gpointer   data ) {
   printf ("Main window destroy\n");
   unregisterme();
   gtk_main_quit();
}




gint sendtalk(gpointer data) {
   if (talktries == -1) {
      printf ("was going to send a talktry, but not needed now.\n");
      return FALSE;
   }
   if(talktries==MAXTALKTRIES) {
      printf("No response to TALK request after %d tries. Giving up.\n",
	     talktries);
      talktries=-1;
      return FALSE;
   }
   ++talktries;
   mesg[0]=CODE_TALK;
   memcpy(mesg+1,username,MAXNAMESIZE);
   mesg[1+MAXNAMESIZE]=0;
   putmsg(&buddy,mesg,1+MAXNAMESIZE);
//   nextsendtalk=gtime()+TALKTRYDELAY;
   return TRUE;
}

unsigned char myvisibleaddr[IPADDRSIZE];
unsigned char myvisibleport[IPPORTSIZE];


#define FOUR 0

int pack(unsigned char *out,unsigned char *in,int size)
{
int i,j;
#if FOUR
	for(j=i=0;i<size;i+=4)
		out[j++]=in[i]&0xf0 | ((in[i+2]&0xf0)>>4);
#else
	for(j=i=0;i<size;i+=2)
		out[j++]=in[i];
#endif
	return j;

}
int unpack(unsigned char *out,unsigned char *in,int size)
{
int i,j,k;
#if FOUR
	for(j=i=0;i<size;++i)
	{
		k=in[i];
		out[j++]=k&0xf0;
		out[j++]=k&0xf0;
		out[j++]=(k&0x0f)<<4;
		out[j++]=(k&0x0f)<<4;
	}
#else
	for(j=i=0;i<size;++i)
	{
		k=in[i];
		out[j++]=k;
		out[j++]=k;
	}
#endif
	return j;
}

void answer(void)
{
   gottalk=0;
   talktries=-1;
   tryopendsp();
   if (GTK_WIDGET_VISIBLE (online_dlg)) {
   } else {
      gtk_widget_show(online_dlg);
   }
   connected=1;
}

void userprocessmsg(struct sockaddr_in *from,unsigned char *msg,int size) {
   long int i,j,k;
   char name[MAXNAMESIZE+1];
   char txt[64];
   char txt2[64];
   unsigned char publicaddr[4];
   unsigned char publicport[4];
   unsigned char localaddr[4];
   unsigned char localport[2];
   
   if(size<1) return;
   if(*msg==CODE_CRYPT) {
      ++msg;
      --size;
      if(size<sizeof(specialkey)) return;
      encryptblock(msg,size,mykey);
      i=size;
      while(--i>0) {
	 msg[i]^=msg[i-1];
      }
      if(memcmp(msg,specialkey,sizeof(specialkey))) return;
      msg+=sizeof(specialkey);
      size-=sizeof(specialkey);
   }

   if(size<1) return;
   --size;
   switch(*msg++) {
    case CODE_ENTRY:
      if(memcmp(&servername.sin_addr.s_addr,&from->sin_addr.s_addr,IPADDRSIZE))
	break;
      if(memcmp(&servername.sin_port,&from->sin_port,IPPORTSIZE))
	break;
      
      if(size<STATSIZE) break;
      memcpy(publicaddr,msg,IPADDRSIZE);
      memcpy(publicport,msg+IPADDRSIZE,IPPORTSIZE);
      memcpy(localaddr,msg+IPADDRSIZE+IPPORTSIZE,IPADDRSIZE);
      memcpy(localport,msg+IPADDRSIZE*2+IPPORTSIZE,IPPORTSIZE);
      memset(name,0,sizeof(name));
      memcpy(name,msg+12,MAXNAMESIZE);
      if(!strcmp(name,username)) {
	 memcpy(myvisibleaddr,publicaddr,IPADDRSIZE);
	 memcpy(myvisibleport,publicport,IPPORTSIZE);
      } else 	{
	 sprintf(txt,"%d.%d.%d.%d:%d",msg[0],msg[1],msg[2],msg[3],
		 (msg[4]<<8)|msg[5]);
	 sprintf(txt2,"%d.%d.%d.%d:%d",localaddr[0],localaddr[1],
		 localaddr[2],localaddr[3],(localport[0]<<8)|localport[1]);
	 printf("%-21s Local:%-21s: %s\n",txt,txt2,name);
	 ChainInsert(userInfo,name,1);
      }
      
      if(!connected && tryingtocall && !strcmp(name,calling)) {
	 if(!memcmp(publicaddr,myvisibleaddr,IPADDRSIZE)) {
	    memcpy(&buddy.sin_addr.s_addr,localaddr,IPADDRSIZE);
	    memcpy(&buddy.sin_port,localport,IPPORTSIZE);
	 } else {
	    memcpy(&buddy.sin_addr.s_addr,publicaddr,IPADDRSIZE);
	    memcpy(&buddy.sin_port,publicport,IPPORTSIZE);
	 }
	 buddy.sin_family=AF_INET;
	 talktries=0;
	 /*
	  * Add a timeout for sending a talk attempt
	  * TALKTRYDELAY second timeout
	  */
	 gtk_timeout_add((TALKTRYDELAY * 1000), sendtalk, NULL);
      }
      break;
    case CODE_SOUND:
      if(!connected) {
	 printf("got some sound...\n");
	 if(talktries>=0 && 
	    !memcmp(&from->sin_addr.s_addr,&buddy.sin_addr.s_addr,IPADDRSIZE) &&
	    !memcmp(&from->sin_port,&buddy.sin_port,IPPORTSIZE)) {
	    memcpy(&buddy,from,sizeof(buddy));
	    answer();
	 } else {
	    mesg[0]=CODE_BYE;
	    putmsg(from,mesg,1);
	    break;
	 }
      }
      if(size>3) {
	 j=(msg[0]<<16) | (msg[1]<<8) | msg[2];
	 msg+=3;
	 k=(msg[0]<<24) | (msg[1]<<16) | (msg[2]<<8) | msg[3];
	 msg+=4;
	 lastdiff=gtime2()-k;
	 k=(msg[0]<<24) | (msg[1]<<16) | (msg[2]<<8) | msg[3];
	 msg+=4;
	 latency=lastdiff+k;
	 
	 if(j>incount) {
	    incount=j;
	    for(i=0;i<PACKETSTOPACK;++i) {
	       unpack33to160(sndblock2,msg+i*33);
	       writein+=block160size;
	       j=writelimit-writeput;
	       if(j>block160size) j=block160size;
	       memcpy(writeput,sndblock2,j);
	       writeput+=j;
	       if(writeput==writelimit) {
		  writeput=writefifo;
		  if(j<block160size) {
		     memcpy(writeput,sndblock2+j,block160size-j);
		     writeput+=block160size-j;
		  }
	       }
	    }
	 } else {
	    printf("Got packet with id %d, I've received up to %d\n",j,incount);
	 }
      }
      break;
    case CODE_TALK:
      if(connected) break;
      mesg[1+MAXNAMESIZE]=0;
      printf("Received TALK from %s\n",mesg+1);
      gottalk=1;
      memcpy(&buddy,from,sizeof(buddy));
      if(havedsp) {
	 chime();
      } else {
	 opendsp();
	 chime();
	 closedsp();
      }
      gtk_label_set_text(GTK_LABEL(popup_label),mesg+1);
      if (GTK_WIDGET_VISIBLE (popup_dlg)) {
      } else {
	 gtk_widget_show(popup_dlg);
      }
      break;
    case CODE_BYE:
      if(!connected) break;
      if(memcmp(&buddy.sin_addr.s_addr,&from->sin_addr.s_addr,IPADDRSIZE))
	break;
      if(memcmp(&buddy.sin_port,&from->sin_port,IPPORTSIZE)) break;
      closedsp();
      connected=0;
      memset(&buddy,0,sizeof(buddy));
      printf("Disconnected, received BYE\n");
      break;
    case CODE_NAME:
      ChainInsert(userInfo,msg,0);
      break;
    case CODE_UNKNOWN:
      printf("Received a CODE_UNKNOWN from the matcher, which means your\n");
      printf("email address identity is unknown to the server. Check your\n");
      printf(".phonerc file.\n");
      break;
    case CODE_EMPTY:
      printf("--Empty list--\n");
      printf("Your contact list is empty. Add names to your contact list\n");
      printf("and get them to add your name to theirs.\n");
      break;
    case CODE_INVALID:
      printf("Server claims your password is invalid. Check your .phonerc\n");
      printf("file and make sure you put in the pass line from the email\n");
      printf("you should have received.\n");
      break;
    case CODE_NOONE:
      printf("No one in your contact list is online\n");
      break;
   }
}

int iswhite(int c)
{
	return c==' ' || c=='\t' || c=='\n' || c=='\r';
}

void token(char *put,int len,char **take)
{
	while(**take && iswhite(**take)) ++(*take);
	while(**take && !iswhite(**take) && len>1)
	{
		*put++=*(*take)++;
		--len;
	}
	*put=0;
}

void report(void) {
   int t;
   
   if(!havedsp || !connected) {
      printf("Not connected to anyone\n");
      return;
   }
   t=gtime2();
   printf("%9ld: msec dsp open\n",t-dspopentime);
   printf("%9ld: msec of sound data written to dsp\n",totalwritten>>3+1);
   printf("%9ld: msec of sound data read from dsp\n",totalread>>3+1);
   printf("%9ld: outcount\n",outcount);
   printf("%9ld: incount\n",incount);
   printf("%9ld: msec latency\n",latency);
   printf("%9d: msec writein\n",writein>> (block160size==160 ? 3 : 4));
}

void dobye() {
   if(!connected) return;
   printf("Sending BYE packet.\n");
   mesg[0]=CODE_BYE;
   putmsg(&buddy,mesg,1);
   memset(&buddy,0,sizeof(buddy));
   connected=0;
   if (GTK_WIDGET_VISIBLE (online_dlg)) {
      gtk_widget_hide(online_dlg);
   } else {
   }
   closedsp();
}

void processtyped(int com, char * data) {
   char *resolved;
   static char msg[20];
   
   tryingtocall=0;
   /*
    * 1 - call
    * 2 - who
    * 3 - bye
    * 4 - info
    * 5 - alias
    * 6 - quit
    * 7 - answer
    * 8 - add
    * 9 - del
    * 10 - list
    */
   switch (com) {
    case 1:
      if(connected) {
	 printf("You're already connected. Use \"bye\" to disconnect.\n");
      } else {
	 tryingtocall=1;
	 resolved=findalias(data);
	 if(!resolved) resolved=data;
	 printf("Trying to call %s\n",resolved);
	 strcpy(calling,resolved);
	 msg[0]=CODE_CALL;
	 computehash(msg+1,resolved);
	 messagetoserver(msg,9);
      }
      break;
    case 2:
      msg[0]=CODE_WHO;
      messagetoserver(msg,1);
      break;
    case 3:
      if(!connected) {
	 printf("You're not connected.\n");
      } else {
	 dobye();
      }
      break;
    case 4:
      report();		
      break;
    case 5:
      listaliases();
      break;
    case 6:
      dobye();
      unregisterme();
      exitflag=1;
      break;
    case 7:
      if(gottalk) {
	 answer();
      } else {
	 printf("You haven't received a TALK request.\n");
      }
      break;
    case 8:
      resolved=findalias(data);
      if(!resolved) resolved=data;
      printf("Trying to add %s\n",resolved);
      msg[0]=CODE_ADD;
      computehash(msg+1,resolved);
      messagetoserver(msg,9);
      break;
    case 9:
      resolved=findalias(data);
      if(!resolved) resolved=data;
      printf("Trying to remove %s\n",resolved);
      msg[0]=CODE_REMOVE;
      computehash(msg+1,resolved);
      messagetoserver(msg,9);
      break;
    case 10:
      msg[0]=CODE_LIST;
      messagetoserver(msg,1);
      break;
    default:
      printf("Commands:\n");
      printf("add <username>     = add user to your contact list\n");
      printf("alias              = list aliases\n");
      printf("answer             = answer a TALK request\n");
      printf("bye                = disconnect call\n");
      printf("call <username>    = make call\n");
      printf("del <username>     = remove user from your contact list\n");
      printf("info               = print out some statistics\n");
      printf("list               = printout contact list\n");
      printf("quit               = quit out of program\n");
      printf("who                = query server for who in your contact list is online\n");
      printf("---\n");
      break;
   }
}

#define THRESHOLD (8<<8)
int checkloud(unsigned char *p)
{
int i,j,max,min;
	i=160;
	max=-5000;
	min=5000;
	while(i--)
	{
		j=*p++;
		j|=*p++<<8;
		if(j>=0x8000) j-=0x10000;
		if(j<min) min=j;
		if(j>max) max=j;
	}
	if(max-min>THRESHOLD) return 1;
	return 0;
}

void cchandler(int num)
{
	signal(SIGINT,SIG_IGN);
}
#define VOL 0x20
chime() {
   unsigned char buff[1024];
   int i;
   if(!havedsp) return;
   if(block160size==160)
     {
	for(i=0;i<160;++i)
	  if(i%40<20) buff[i]=0x80-VOL;
	else buff[i]=0x80+VOL;
     } else
     {
	for(i=0;i<160;++i)
	  if(i%40<20) buff[i+i]=0,buff[i+i+1]=-VOL;
	else buff[i+i]=0,buff[i+i+1]=VOL;
     }
   for(i=0;i<8;++i)
     write(sndin,buff,block160size);
}


gint addToList(GtkWidget *widget, gpointer data) {
   GtkWidget * entry = data;
   char * text;
   text = gtk_entry_get_text(GTK_ENTRY(entry));
   processtyped(8,text);
   gtk_timeout_add(500,updateList,NULL);
   return FALSE;
}

gint delFromList(GtkWidget *widget, gpointer data) {
   GtkWidget * entry = data;
   char * text;
   text = gtk_entry_get_text(GTK_ENTRY(entry));
   processtyped(9,text);
   gtk_entry_set_text(GTK_ENTRY(entry),"");
   gtk_timeout_add(500,updateList,NULL);
   return FALSE;
}

gint acceptTypedData(GtkWidget *widget, gpointer data) {
   GtkWidget * entry = data;
   char * text;
   int len;
   text = gtk_entry_get_text(GTK_ENTRY(entry));
   processtyped(1,text);
   gtk_entry_set_text(GTK_ENTRY(entry),"");
   return FALSE;
}


void addressBookEntrySelected( GtkWidget      *clist,
			      gint            row,
			      gint            column,
			      GdkEventButton *event,
			      gpointer        data ) {
   gchar *text;
   GtkWidget * entry = data;
   gtk_clist_get_text(GTK_CLIST(clist), row, 1, &text);
   gtk_entry_set_text(GTK_ENTRY(entry),text);

   return;
}

GtkWidget* create_online_popup (void) {
   GtkWidget *window2;
   GtkWidget *frame2;
  GtkWidget *vbox2;
  GtkWidget *label3;
  GtkWidget *label4;
  GtkWidget *hseparator2;
  GtkWidget *hbox2;
  GtkWidget *button3;

  window2 = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (window2), "window2", window2);
  gtk_window_set_title (GTK_WINDOW (window2), _("window2"));
  gtk_window_set_policy (GTK_WINDOW (window2), TRUE, FALSE, TRUE);

  frame2 = gtk_frame_new (NULL);
  gtk_widget_ref (frame2);
  gtk_object_set_data_full (GTK_OBJECT (window2), "frame2", frame2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame2);
  gtk_container_add (GTK_CONTAINER (window2), frame2);

  vbox2 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox2);
  gtk_object_set_data_full (GTK_OBJECT (window2), "vbox2", vbox2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox2);
  gtk_container_add (GTK_CONTAINER (frame2), vbox2);
  gtk_container_set_border_width (GTK_CONTAINER (vbox2), 8);

  label3 = gtk_label_new (_("Talk in progress"));
  gtk_widget_ref (label3);
  gtk_object_set_data_full (GTK_OBJECT (window2), "label3", label3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label3);
  gtk_box_pack_start (GTK_BOX (vbox2), label3, FALSE, FALSE, 0);

  label4 = gtk_label_new (_("Press button to End."));
  gtk_widget_ref (label4);
  gtk_object_set_data_full (GTK_OBJECT (window2), "label4", label4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label4);
  gtk_box_pack_start (GTK_BOX (vbox2), label4, FALSE, FALSE, 3);

  hseparator2 = gtk_hseparator_new ();
  gtk_widget_ref (hseparator2);
  gtk_object_set_data_full (GTK_OBJECT (window2), "hseparator2", hseparator2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hseparator2);
  gtk_box_pack_start (GTK_BOX (vbox2), hseparator2, FALSE, FALSE, 3);

  hbox2 = gtk_hbox_new (TRUE, 8);
  gtk_widget_ref (hbox2);
  gtk_object_set_data_full (GTK_OBJECT (window2), "hbox2", hbox2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox2);
  gtk_box_pack_start (GTK_BOX (vbox2), hbox2, FALSE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (hbox2), 3);

  button3 = gtk_button_new_with_label (_("End Talk"));
  gtk_widget_ref (button3);
  gtk_object_set_data_full (GTK_OBJECT (window2), "button3", button3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button3);
  gtk_box_pack_start (GTK_BOX (hbox2), button3, FALSE, FALSE, 0);

   gtk_signal_connect(GTK_OBJECT(button3), "clicked",
		      GTK_SIGNAL_FUNC(buttonEndConversation),
		      NULL);
   
  return window2;

}

GtkWidget* create_incoming_popup (void) {
   GtkWidget *window1;
   GtkWidget *vbox1;
   GtkWidget *label1;
   GtkWidget *label2;
   GtkWidget *hseparator1;
   GtkWidget *hbox1;
   GtkWidget *frame1;
   GtkWidget *button1;
   GtkWidget *button2;
   

  window1 = gtk_window_new (GTK_WINDOW_DIALOG);
  gtk_object_set_data (GTK_OBJECT (window1), "window1", window1);
  gtk_window_set_title (GTK_WINDOW (window1), _("window1"));
  gtk_window_set_position (GTK_WINDOW (window1), GTK_WIN_POS_CENTER);
  gtk_window_set_policy (GTK_WINDOW (window1), TRUE, FALSE, TRUE);

  frame1 = gtk_frame_new (NULL);
  gtk_widget_ref (frame1);
  gtk_object_set_data_full (GTK_OBJECT (window1), "frame1", frame1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame1);
  gtk_container_add (GTK_CONTAINER (window1), frame1);

  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox1);
  gtk_object_set_data_full (GTK_OBJECT (window1), "vbox1", vbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (frame1), vbox1);
  gtk_container_set_border_width (GTK_CONTAINER (vbox1), 8);

  label1 = gtk_label_new (_("Bzzt!\nIncoming call from:"));
  gtk_widget_ref (label1);
  gtk_object_set_data_full (GTK_OBJECT (window1), "label1", label1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label1);
  gtk_box_pack_start (GTK_BOX (vbox1), label1, FALSE, FALSE, 0);

   popup_label = gtk_label_new (_("[unknown]"));
   gtk_widget_ref (popup_label);
   gtk_object_set_data_full (GTK_OBJECT (window1), "popup_label", popup_label,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (popup_label);
   gtk_box_pack_start (GTK_BOX (vbox1), popup_label, FALSE, FALSE, 3);
   
  hseparator1 = gtk_hseparator_new ();
  gtk_widget_ref (hseparator1);
  gtk_object_set_data_full (GTK_OBJECT (window1), "hseparator1", hseparator1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hseparator1);
  gtk_box_pack_start (GTK_BOX (vbox1), hseparator1, FALSE, FALSE, 3);

  hbox1 = gtk_hbox_new (TRUE, 8);
  gtk_widget_ref (hbox1);
  gtk_object_set_data_full (GTK_OBJECT (window1), "hbox1", hbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox1);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox1, FALSE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (hbox1), 3);

  button1 = gtk_button_new_with_label (_("Accept"));
  gtk_widget_ref (button1);
  gtk_object_set_data_full (GTK_OBJECT (window1), "button1", button1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button1);
  gtk_box_pack_start (GTK_BOX (hbox1), button1, FALSE, FALSE, 0);

  button2 = gtk_button_new_with_label (_("Ignore"));
  gtk_widget_ref (button2);
  gtk_object_set_data_full (GTK_OBJECT (window1), "button2", button2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button2);
  gtk_box_pack_start (GTK_BOX (hbox1), button2, FALSE, FALSE, 0);

   
   gtk_signal_connect(GTK_OBJECT(button1), "clicked",
		      GTK_SIGNAL_FUNC(answerTalkRequest),
		      NULL);
   
   gtk_signal_connect(GTK_OBJECT(button2), "clicked",
		      GTK_SIGNAL_FUNC(ignoreTalkRequest),
		      NULL);
   
   
   return window1;
}

   
GtkWidget* create_gui_main (int udpsocket) {

   GtkWidget *window1;
   GtkWidget *vbox1;
   GtkWidget *hbox1;
   GtkWidget *vbox3;
   GtkWidget *hbox2;
   GtkWidget *label1;
   GtkWidget *label2;
   GtkWidget *label3;
   GtkWidget *entry1;
   GtkWidget *hbox3;
   GtkWidget *button1;
   GtkWidget *button2;
   GtkWidget *scrolledwindow1;
   GtkWidget *viewport1;
   GtkWidget *scrolledwindow2;
   GtkWidget *hseparator1;
   GtkWidget *hbox4;
   GtkWidget *button3;
   GtkWidget *button4;
   GtkWidget *button5;

  window1 = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (window1), "window1", window1);
  gtk_window_set_title (GTK_WINDOW (window1), _("window1"));
   gtk_widget_set_usize (window1, 200, 300);
   
  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox1);
  gtk_object_set_data_full (GTK_OBJECT (window1), "vbox1", vbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (window1), vbox1);

  hbox1 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox1);
  gtk_object_set_data_full (GTK_OBJECT (window1), "hbox1", hbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox1);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox1, FALSE, TRUE, 0);

  vbox3 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox3);
  gtk_object_set_data_full (GTK_OBJECT (window1), "vbox3", vbox3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox3);
  gtk_box_pack_start (GTK_BOX (vbox1), vbox3, TRUE, TRUE, 0);

  hbox2 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox2);
  gtk_object_set_data_full (GTK_OBJECT (window1), "hbox2", hbox2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox2);
  gtk_box_pack_start (GTK_BOX (vbox3), hbox2, FALSE, FALSE, 0);

  label1 = gtk_label_new (_("Name"));
  gtk_widget_ref (label1);
  gtk_object_set_data_full (GTK_OBJECT (window1), "label1", label1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label1);
  gtk_box_pack_start (GTK_BOX (hbox2), label1, FALSE, FALSE, 0);

  entry1 = gtk_entry_new ();
  gtk_widget_ref (entry1);
  gtk_object_set_data_full (GTK_OBJECT (window1), "entry1", entry1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (entry1);
  gtk_box_pack_start (GTK_BOX (hbox2), entry1, TRUE, TRUE, 0);

   button5 = gtk_button_new_with_label (_("Call"));
  gtk_widget_ref (button5);
  gtk_object_set_data_full (GTK_OBJECT (window1), "button5", button5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button5);
  gtk_box_pack_start (GTK_BOX (hbox2), button5, FALSE, FALSE, 0);


   
  hbox3 = gtk_hbox_new (TRUE, 0);
  gtk_widget_ref (hbox3);
  gtk_object_set_data_full (GTK_OBJECT (window1), "hbox3", hbox3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox3);
  gtk_box_pack_start (GTK_BOX (vbox3), hbox3, FALSE, FALSE, 3);

  button1 = gtk_button_new_with_label (_("Add to List"));
  gtk_widget_ref (button1);
  gtk_object_set_data_full (GTK_OBJECT (window1), "button1", button1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button1);
  gtk_box_pack_start (GTK_BOX (hbox3), button1, FALSE, FALSE, 0);

  button2 = gtk_button_new_with_label (_("Remove"));
  gtk_widget_ref (button2);
  gtk_object_set_data_full (GTK_OBJECT (window1), "button2", button2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button2);
  gtk_box_pack_start (GTK_BOX (hbox3), button2, FALSE, FALSE, 0);

  scrolledwindow1 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow1);
  gtk_object_set_data_full (GTK_OBJECT (window1), "scrolledwindow1", scrolledwindow1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow1);
  gtk_box_pack_start (GTK_BOX (vbox3), scrolledwindow1, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow1), GTK_POLICY_NEVER, GTK_POLICY_AUTOMATIC);


   viewport1 = gtk_viewport_new (NULL, NULL);
   gtk_widget_ref (viewport1);
   gtk_object_set_data_full (GTK_OBJECT (window1), "viewport1", viewport1,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (viewport1);
   gtk_container_add (GTK_CONTAINER (scrolledwindow1), viewport1);
   
   scrolledwindow2 = gtk_scrolled_window_new (NULL, NULL);
   gtk_widget_ref (scrolledwindow2);
   gtk_object_set_data_full (GTK_OBJECT (window1), "scrolledwindow2", scrolledwindow2,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (scrolledwindow2);
   gtk_container_add (GTK_CONTAINER (viewport1), scrolledwindow2);
   gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow2), GTK_POLICY_NEVER, GTK_POLICY_AUTOMATIC);
   
   clist1 = gtk_clist_new (2);
   gtk_widget_ref (clist1);
   gtk_object_set_data_full (GTK_OBJECT (window1), "clist1", clist1,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (clist1);
   gtk_container_add (GTK_CONTAINER (scrolledwindow2), clist1);
   gtk_clist_set_column_width (GTK_CLIST (clist1), 0, 20);
   gtk_clist_set_column_width (GTK_CLIST (clist1), 1, 80);
   gtk_clist_column_titles_show (GTK_CLIST (clist1));
   
   label2 = gtk_label_new (_("On"));
   gtk_widget_ref (label2);
   gtk_object_set_data_full (GTK_OBJECT (window1), "label2", label2,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (label2);
   gtk_clist_set_column_widget (GTK_CLIST (clist1), 0, label2);
   
   label3 = gtk_label_new (_("Address"));
   gtk_widget_ref (label3);
   gtk_object_set_data_full (GTK_OBJECT (window1), "label3", label3,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (label3);
   gtk_clist_set_column_widget (GTK_CLIST (clist1), 1, label3);
   
   
  hseparator1 = gtk_hseparator_new ();
  gtk_widget_ref (hseparator1);
  gtk_object_set_data_full (GTK_OBJECT (window1), "hseparator1", hseparator1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hseparator1);
  gtk_box_pack_start (GTK_BOX (vbox3), hseparator1, FALSE, TRUE, 3);

  hbox4 = gtk_hbox_new (TRUE, 0);
  gtk_widget_ref (hbox4);
  gtk_object_set_data_full (GTK_OBJECT (window1), "hbox4", hbox4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox4);
  gtk_box_pack_start (GTK_BOX (vbox3), hbox4, FALSE, FALSE, 0);

  button3 = gtk_button_new_with_label (_("Refresh List"));
  gtk_widget_ref (button3);
  gtk_object_set_data_full (GTK_OBJECT (window1), "button3", button3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button3);
  gtk_box_pack_start (GTK_BOX (hbox4), button3, FALSE, FALSE, 0);
   
   popup_dlg = create_incoming_popup();
   online_dlg = create_online_popup();
   
   /* 
    * initial registration
    */
   registerme(NULL);
   /*
    * Tell the server I'm around every 60 seconds.
    */
   gtk_timeout_add((UPDATETIME * 1000),registerme,NULL);
   /*
    * Add callbacks for udp input and dsp i/o
    */
   gdk_input_add(udpsocket, GDK_INPUT_READ, udp_message_callback, NULL);
   /*
    * Don't add callbacks for the dsp yet, only when it's been opened.
    */
   gtk_signal_connect(GTK_OBJECT(clist1), "select_row",
		      GTK_SIGNAL_FUNC(addressBookEntrySelected),
		      entry1);
   
   gtk_signal_connect(GTK_OBJECT(entry1), "activate",
		      GTK_SIGNAL_FUNC(acceptTypedData),
		      entry1);
   gtk_signal_connect(GTK_OBJECT(button5), "clicked",
		      GTK_SIGNAL_FUNC(acceptTypedData),
		      entry1);

   gtk_signal_connect(GTK_OBJECT(button1), "clicked",
		      GTK_SIGNAL_FUNC(addToList),
		      entry1);
   gtk_signal_connect(GTK_OBJECT(button2), "clicked",
		      GTK_SIGNAL_FUNC(delFromList),
		      entry1);

   gtk_signal_connect(GTK_OBJECT(button3), "clicked",
		      GTK_SIGNAL_FUNC(buttonUpdateClist),
		      entry1);

   gtk_signal_connect (GTK_OBJECT (window1), "delete_event",
			GTK_SIGNAL_FUNC (endProgram), NULL);
   
   return window1;
}


void udp_message_callback(gpointer data,gint source,GdkInputCondition condition ) {
   int size=getmsg(0);
   if(size>0) {
      //		      printf ("received control input\n");
      userprocessmsg(&sender,mesg,size);
   }
}

void incoming_dsp_callback(gpointer data,gint source,GdkInputCondition condition ) {
   int size,i;
   static int samplesin = 0;
   if (!havedsp) {
      return;
   }
   size=read(sndin,sndblock1+samplesin,sndblocksize);
   if(connected && size>0) {
      totalread+=size;
      samplesin+=size;
      i=0;
      while(samplesin-i>=block160size) {
	 loudcount+=checkloud(sndblock1+i);
	 pack160to33(packed+12+packedin*33,sndblock1+i);
	 i+=block160size;
	 ++packedin;
	 if(packedin==PACKETSTOPACK) {
	    long now;
	    now=gtime2();
	    packed[0]=CODE_SOUND;
	    packed[1]=outcount>>16;
	    packed[2]=outcount>>8;
	    packed[3]=outcount;
	    packed[4]=now>>24;
	    packed[5]=now>>16;
	    packed[6]=now>>8;
	    packed[7]=now;
	    packed[8]=lastdiff>>24;
	    packed[9]=lastdiff>>16;
	    packed[10]=lastdiff>>8;
	    packed[11]=lastdiff;
	    ++outcount;
	    putmsg(&buddy,packed,12+PACKETSTOPACK*33);
	    
	    packedin=0;
	    loudcount=0;
	 }
      }
      if(i) {
	 samplesin-=i;
	 memcpy(sndblock1,sndblock1+i,samplesin);
      }
   }
}

void outgoing_dsp_callback(gpointer data,gint source,GdkInputCondition condition ) {
   if (!havedsp) {
      return;
   }
   if(writein>=sndblocksize*(MAXBLOCKS+1)) {
      while(writein>=sndblocksize<<1) {
	 writein-=sndblocksize;
	 writetake+=sndblocksize;
	 if(writetake==writelimit) {
	    writetake=writefifo;
	 }
      }
   }
   write(sndin,writetake,sndblocksize);
   totalwritten+=sndblocksize;
   
   writein-=sndblocksize;
   writetake+=sndblocksize;
   if(writetake==writelimit) {
      writetake=writefifo;
   }
}





main(int argc,char *argv[])
{
   int size,pid,result,port;
   long nexttime,t;
   fd_set inputs,outputs;
   struct timeval timeout;
   char typed[256];
   int samplesin;
   int i,j;
   char *s;
   GtkWidget * mainWindow;
   unsigned char *p;
   gtk_init (&argc, &argv);
   userInfo = CreateBucket("---",0);
//	cchandler(0);
   inittime();
   srand(timebase);
   myiplen=getmyip(myip);
   if(myiplen<0) {
      printf("Failed to determine local IP address, code %d\n",myiplen);
      return -60;
   }
   scanrcfile(0);
   if(!findalias("me"))
     addalias("me",username);
   for(i=0;i<KEYSIZE;++i)
     if(mykey[i]) break;
   if(i==KEYSIZE) {
      printf("WARNING:You haven't specificied your password in the PHONERC file.\n");
      printf("Pretty much nothing will work without that password. Visit the site\n");
      printf("   http://www.linuxmotors.com/phone\n");
      printf("and follow the link there to get a password assigned.\n");
   }
   computehash(myhash,username);

   havedsp=0;
   dropDspHandles();
   initinputcompression();
   initoutputcompression();
   
   i=opendsp();
   if(i) {
      printf("Failed to open dsp for test, code %d\n",i);
   }
   closedsp();

   if(!openserver(SERVER,PORT))
     {
	printf("Failed to resolve server %s\n",s);
	exit(2);
     }

   getsocket(0);
   
   exitflag=0;
   loudcount=0;
   samplesin=0;
   connected=0;
   gottalk=0;
   nexttime=gtime();
   talktries=-1;
   mainWindow = create_gui_main(udpsocket);
   gtk_widget_show(mainWindow);
   updateList(NULL);
   gtk_main();
}
