#include "user_info.h"
#include <string.h>
#include <stdlib.h>

T_bucket CreateBucket(string key, int online) {
   T_bucket b = malloc(sizeof *b);
   b->name    = strdup(key);
   b->online  = online;
   b->next    = NULL;
//   printf ("added bucket %s (%d)\n",b->name,b->online);
   return b;
}

void ChainInsert(T_bucket chain,string name, int online) {
//   printf ("inserting %s (%d)\n",name,online);
   T_bucket previous = chain;
   for (chain = chain->next; chain ; previous = chain, chain = chain->next) {
      if (!strcmp(chain->name,name)) {
	 if (online) {
	    chain->online = online;
	 } else {
	 }
	 return;
      }
   }
   previous->next = CreateBucket(name,online);
}

void destroyBuckets(T_bucket thisBucket) {
   if (thisBucket) {
      if (thisBucket->next) {
	 destroyBuckets(thisBucket->next);
      }
      free (thisBucket->name);
      free (thisBucket);
   }
}

void ChainDestroy(T_bucket bucket) {
   destroyBuckets(bucket->next);
   bucket->next = NULL;
}
